#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/mman.h>
#include <mpi.h>


int main (int argc, char *argv[]) {
      int err;
      char portA[MPI_MAX_PORT_NAME],  portB[MPI_MAX_PORT_NAME];
      MPI_Comm comm_intra, comm_aux, comm_agg;
      MPI_Comm	pool_comm[2];

      MPI_Init(&argc, &argv);

      err = MPI_Lookup_name( "serverA", MPI_INFO_NULL, portA );
      if (err) {                             
	   fprintf(stderr, "Error in MPI_Lookup_name\n");
      }
      err = MPI_Comm_connect(portA, MPI_INFO_NULL, 0, MPI_COMM_WORLD, &pool_comm[0]);
	  
      MPI_Intercomm_merge( pool_comm[0], 0, &comm_agg );
	

      err = MPI_Lookup_name( "serverB", MPI_INFO_NULL, portB );
      if (err) {                             
	   fprintf(stderr, "Error in MPI_Lookup_name\n");
      }
      err = MPI_Comm_connect(portB, MPI_INFO_NULL, 0, MPI_COMM_WORLD, &pool_comm[1]);

      /* First we create a intercommnunicator between client and serverA  */
      /* Local processes on the left */
      MPI_Intercomm_merge( pool_comm[1], 0, &comm_intra );

      /* We create a client-serverA intercommunicator with serverB    */
      MPI_Intercomm_create( comm_agg, 0,  comm_intra, 1, 12345  , &comm_aux ); 

      /* Finnaly we create a new intracommunicator containing client, serverA, and serverB */
      MPI_Intercomm_merge( comm_aux, 0, &comm_agg); 
     
      /* Some awesome code here ....  */

      MPI_Finalize();
      return 0;
}
